//+------------------------------------------------------------------+
//|                                                Fractal Store.mq4 |
//|                                                            Chris |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Chris"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DarkGray
//--- input parameters
extern int       Shift;
extern string    Mode;
int              ModeInt;
//--- buffers
double ExtMapBuffer1[];
double FractalArray[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
ModeInt = MODE_UPPER;
if(Mode=="L")ModeInt = MODE_LOWER;
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
int counted_bars=IndicatorCounted();
if (counted_bars < 0) return(-1);
if (counted_bars < 100)   counted_bars = 100;
for (int pos = Bars - 1 - counted_bars; pos > 0; pos--){
   if(iFractals(Symbol(),0,ModeInt,pos)>0)
   {
   ArrayResize(FractalArray,ArraySize(FractalArray)+1);
   for(int j=ArraySize(FractalArray)-1;j>0;j--){
   FractalArray[j] = FractalArray[j-1];
   }
   FractalArray[0] = iFractals(Symbol(),0,ModeInt,pos);
   }
   if(ArraySize(FractalArray)==0)ExtMapBuffer1[pos]=EMPTY_VALUE;else ExtMapBuffer1[pos]=FractalArray[Shift];
   
}
static datetime currTime;
if(currTime!=iTime(Symbol(),1,0)){
ExtMapBuffer1[0]=FractalArray[Shift];
currTime = iTime(Symbol(),1,0);
}
return (0);
  }
//+------------------------------------------------------------------+